
from twisted.spread import pb
from twisted.cred import checkers, portal, credentials
from twisted.internet import reactor
from twisted.python import log
from twisted.application import internet


def listen(root, portnum):
    f = pb.PBServerFactory(root, unsafeTracebacks=True)
    return internet.TCPServer(portnum, f)

def connect(host, portnum):
    f = pb.PBClientFactory()
    d = f.getRootObject()
    reactor.connectTCP(host, portnum, f)
    return d


def listenForUsers(realm, portnum, users):
    c = checkers.InMemoryUsernamePasswordDatabaseDontUse()
    for user, pw in users:
        c.addUser(user, pw)
    p = portal.Portal(realm)
    p.registerChecker(c)
    f = pb.PBServerFactory(p, unsafeTracebacks=True)
    return internet.TCPServer(portnum, f)

def connectWithUser(host, portnum, user, pw, client=None):
    f = pb.PBClientFactory()
    d = f.login(credentials.UsernamePassword(user, pw), client=client)
    reactor.connectTCP(host, portnum, f)
    return d
