
# this library starts a Petmail gui agent
import sys, os.path
from twisted.application import app
from twisted.python import usage
from petmail.gui import gui

class Options(usage.Options):
    synopsis = "Usage: petmail-gui [options]"

    optParameters = [
        ['basedir','d', os.path.expanduser("~/.petmail"), "base directory"],
        ['fake-crypto', None, 0, "Use simulated crypto library"],
        ['color', None, None, "Background color"],
        ['sheep', None, None, "Sheep animation to use"],
        ['sheep2', None, None, "Animation to use to indicate new mail"],
        ]
    optFlags = [
        ['devel-test', None, "Set up developer-test defaults"],
        ]

    def opt_version(self):
        from petmail import copyright as petmail_copyright
        print "Petmail version:", petmail_copyright.version
        from twisted import copyright as twisted_copyright
        print "Twisted version:", twisted_copyright.version
        print "Python version:", sys.version.replace("\n", "\n  ")
        sys.exit(0)


def run():
    config = Options()
    try:
        config.parseOptions()
    except usage.error, ue:
        print config
        print "%s: %s" % (sys.argv[0], ue)
    else:
        if int(config['fake-crypto']):
            print "using fake crypto stubs"
            from petmail import crypto
            crypto.EncryptionAgent = crypto.FakeEncryptionAgent

        gui.run(config)
