#! /usr/bin/python

from petmail import interfaces
from petmail.transport import base

dummyInlets = {}
class DummyInlet(base.BaseInlet):
    """DummyInlet/DummyTransport are paired like PTY devices. Both live in
    the same process, and writing to one causes the message to be emitted on
    the other. Used only for testing.

    Dummy:name
    """
    __implements__ = (base.BaseInlet.__implements__,
                      interfaces.IInlet2_Dummy)
    itype = "dummy"

    def __init__(self, name):
        base.BaseInlet.__init__(self)
        self.name = name
        dummyInlets[self.name] = self
        self.description = "Dummy:%s" % self.name
    def encode(self):
        return ("Dummy", self.name)
    def accept(self, encrypted):
        return self.gotMessage(encrypted)
    def __cmp__(self, other):
        return (cmp(type(self), type(other)) or
                cmp(self.__class__, other.__class__) or
                cmp(self.name, other.name))
    def __hash__(self):
        return hash((self.__class__, self.name))

    def getProperty(self, pname):
        if pname in ("name"):
            return getattr(self, pname)
        raise IndexError("%s has no property named %s" % (self, pname))

class DummyTransport:
    __implements__ = interfaces.IUntraceableTransport,  # entirely local
    def __init__(self, trecord, message):
        self.name = trecord[1]
    def send(self, encapsulated):
        inlet = dummyInlets[self.name]
        return inlet.accept(encapsulated)
base.registerTransport("Dummy", True, DummyTransport)
